# include "../precc.new/ccx.h"
# include "cobol.lex.h"


	/* ------------ FORMATS ------------------- */

static char *num;

@x_string(b)      = <'X'> [<'('> natnum_rep(&num) <')'> ]

static int ninecount;
static char numbuff[24];

@nine_string(b)   = nines 
@                 |	<'('> natnum_rep(&num) <')'> 

@nines            = <'9'>+

@z_string(b)      = <'Z'> [<'('> natnum_rep(&num) <')'> ]

@open_addlist     =  { [number_rep(&num)] literal_iden }*


	/* integers represented as integer tokens */

@natnum_rep(buff) = (p_isdigit)+

@integer_representation= [ sign ] natnum_rep(&num)

@ sign = <'+'> | <'-'>

	/* my guess .. must start with a digit ? */

@number_rep       =  integer_representation
@                    [ stop natnum_rep(&num) ]
@                    [ ee integer_representation ]

@ee = <'e'> | <'E'>

@identifier(pbuf) = literal_iden

@literal_iden     = alpha alphanums

@alpha            = (p_isalpha)

@alphanums        = alphanum*

@alphanum         = (p_isalnum) 
@                 |	    <'-'> 


char smallbuffer[32];	/* holds integer representations */
int  smallint;          /* the represented integer */

# define FIRSTDIGIT(n) (sprintf(smallbuffer,"%d",n),\
(long)(*smallbuffer-'0'))
# define LASTDIGITS(n) (sprintf(smallbuffer,"%d",n),\
sscanf(&smallbuffer[1],"%d",&smallint),\
(long)smallint)

@level_number(n)   =  <'0'> digit(n)

@number(n)         =  digit(n)
@                  |  digit(FIRSTDIGIT(n)) number(LASTDIGITS(n))     

@digit(n)          =  )(-1<n)&&(n<10)( <n+'0'> 


