
# include "occam.h"

@ construction(n)= seq(n)       | conditional(n)
@                | selection(n) | loop(n) 
@                | parallel(n)  | alternation(n)

@ seq(n)         = _SEQ                      :printf("seq[\n");:
@                  $! [ clauses(n+2) :NL;: ] :SPACES(n);printf("]");:

@ conditional(n) = _IF                       :printf("if[\n"); :
@                  $ [ choices(n+2) :NL;: ]  :SPACES(n);printf("]");:

@ choiceoption(n)= conditional(n)
@                | guardedchoice(n)

@ choice(n)      = [specifications(n)] indent(n,CONST(choiceoption))

@ choice_sep     =                           :printf(",\n");:

@ choices(n)     = sep_list1(CONST(choice_sep),CONST(choice),n)

@guardedchoice(n)=                           :printf("(");:
@                  bool                      :printf(") ->\n");:
@                  $ clause(n+2)

@ bool           = expression

@ selection(n)   = _CASE                     :printf("case[\n");SPACES(n+2);:
@                  somespace selector        :printf(" =>\n");:
@                  $ [ options(n+2) :NL;: ]  :SPACES(n);printf("]");:

@defaultoption(n)= _ELSE                     :printf("true,\n");:
@                  $ clause(n+2) 

@ options(n)     = [ ooptions(n)             :printf(",\n");:
@                  ] indent(n,CONST(defaultoption))
                   	
@ optionoption(n)= caseexpressions           :printf(",\n");:
@                  $ clause(n+2) 

@ ooption(n)     = [specifications(n)] indent(n,CONST(optionoption))

@ option_sep     =                           :printf(",\n");:

@ ooptions(n)    = sep_list1(CONST(option_sep),CONST(ooption),n)

@ selector       = expression

@ caseexpr_sep   = <','>                     :printf(",");:

@ caseexpression = expression

@ caseexpressions= sep_list(CONST(caseexpr_sep),CONST(caseexpression))

@ loop(n)        = _WHILE                    :printf("while[\n");:
@                  somespace                 :printf("(");:
@                  bool                      :printf(") =>\n");:
@                  $! clause(n+2)            :NL;SPACES(n);printf("]");:

@ parallel(n)    = _PAR                      :printf("par[\n");:
@                  $! clause(n+2)            :NL;SPACES(n);printf("]");:

@ alternation(n) = _ALT                      :printf("alt[\n");:
@                  $ [ alternatives(n+2)     :NL;:
@                  ]                         :SPACES(n);printf("]");:

@ alternativeoption(n) = alternative(n)
@                | guardedalternative(n)

@ alternative(n) = [specifications(n)]
@                  indented(n,CONST(alternativeoption))

@ alternative_sep=                           :printf(",\n");:

@ alternatives(n)= sep_list1(CONST(alternative_sep),CONST(alternative),n)

@ guardedalternative(n)= guard 
@                  process(n+2)

@ guard          = input
@                | bool    somespace <'&'> somespace { input | skip }

